﻿using System.Collections.Generic;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Options;
using Volo.Abp.AspNetCore.Mvc.UI.Bundling;
using Volo.Abp.AspNetCore.Mvc.UI.Packages.MalihuCustomScrollbar;
using Volo.Abp.AspNetCore.Mvc.UI.Theme.Commercial;
using Volo.Abp.AspNetCore.Mvc.UI.Theme.Shared.Bundling;
using Volo.Abp.Modularity;

namespace Ravco.Abp.AspNetCore.Mvc.UI.Theme.Front.Bundling;

[DependsOn(
    typeof(SharedThemeGlobalScriptContributor)
)]
public class FrontGlobalScriptContributor : BundleContributor
{
    public override void ConfigureBundle(BundleConfigurationContext context)
    {
        var options = context
            .ServiceProvider
            .GetRequiredService<IOptions<FrontThemeOptions>>()
            .Value;

        context.Files.AddIfNotContains("/Themes/Front/Global/scripts/theme-core.js");

        // if (options.EnableDemoFeatures)
        // {
        //     context.Files.AddIfNotContains("/Themes/Front/Global/scripts/front-demo.js");
        // }
    }
}
