﻿using Microsoft.Extensions.Configuration;
using Volo.Abp.AspNetCore.Mvc.UI.Theming;
using Volo.Abp.DependencyInjection;

namespace Ravco.Abp.AspNetCore.Mvc.UI.Theme.Front;

[ThemeName(Name)]
public class FrontTheme : ITheme, ITransientDependency
{
    public const string Name = "Front";

    private readonly IConfiguration _configuration;

    public FrontTheme(IConfiguration configuration)
    {
        _configuration = configuration;
    }

    public virtual string GetLayout(string name, bool fallbackToDefault = true)
    {
        switch (name)
        {
            case StandardLayouts.Application:
                return GetLayoutFromConfig("Application") ?? "~/Themes/Front/Layouts/Application/Default.cshtml";
            case StandardLayouts.Account:
                return GetLayoutFromConfig("Account") ?? "~/Themes/Front/Layouts/Account/Default.cshtml";
            case StandardLayouts.Public:
                return GetLayoutFromConfig("Public") ?? "~/Themes/Front/Layouts/Public/Default.cshtml";
            case StandardLayouts.Empty:
                return GetLayoutFromConfig("Empty") ?? "~/Themes/Front/Layouts/Empty/Default.cshtml";
            default:
                return fallbackToDefault ? "~/Themes/Front/Layouts/Public/Default.cshtml" : null;
        }
    }

    private string GetLayoutFromConfig(string layoutName)
    {
        return _configuration["FrontTheme:Layouts:" + layoutName];
    }
}
