using JetBrains.Annotations;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.AspNetCore.Mvc.ViewEngines;
using Volo.Abp.UI.Navigation;

namespace Ravco.Abp.AspNetCore.Mvc.UI.Theme.Front.Navigations
{
    public static class ApplicationMenuExtensions
    {
        [CanBeNull]
        public static string GetPartialView([NotNull] this ApplicationMenuItem applicationMenu)
        {
            var str = (string) applicationMenu.CustomData;
            if (string.IsNullOrWhiteSpace(str))
            {
                return null;
            }
            if (str.Contains("FrontMegaMenuPartial"))
            {
                return (string) applicationMenu.CustomData;
            }

            return null;
        }
        
        public static bool PartialViewExist([NotNull] this ViewContext viewContext , ApplicationMenuItem applicationMenu, ICompositeViewEngine engine)
        {
            return engine.FindView(viewContext, applicationMenu.GetPartialView(), isMainPage: false).Success;
        }
    }
}