﻿using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Volo.Abp.UI.Navigation;

namespace Ravco.Abp.AspNetCore.Mvc.UI.Theme.Front.Themes.Front.Components.Public.Header.Navbar.UserMenu;

public class PublicHeaderNavbarUserMenuViewComponent : FrontViewComponentBase
{
    protected IMenuManager MenuManager;

    public PublicHeaderNavbarUserMenuViewComponent(IMenuManager menuManager)
    {
        MenuManager = menuManager;
    }

    public virtual async Task<IViewComponentResult> InvokeAsync()
    {
        var menu = await MenuManager.GetAsync(StandardMenus.User);
        return View("~/Themes/Front/Components/Public/Header/Navbar/UserMenu/Default.cshtml", menu);
    }
}
