﻿using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Ravco.Abp.AspNetCore.Mvc.UI.Theme.Front.Toolbars;
using Volo.Abp.AspNetCore.Mvc.UI.Theme.Shared.Toolbars;

namespace Ravco.Abp.AspNetCore.Mvc.UI.Theme.Front.Themes.Front.Components.Public.Header.Topbar;

public class PublicHeaderTopbarViewComponent : FrontViewComponentBase
{
    protected IToolbarManager ToolbarManager;

    public PublicHeaderTopbarViewComponent(IToolbarManager toolbarManager)
    {
        ToolbarManager = toolbarManager;
    }

    public virtual async Task<IViewComponentResult> InvokeAsync()
    {
        var toolbar = await ToolbarManager.GetAsync(FrontToolbars.Public.Topbar);
        return View("~/Themes/Front/Components/Public/Header/Topbar/Default.cshtml", toolbar);
    }
}
