var gulp = require('gulp'),
  rename = require('gulp-rename'),
  uglify = require('gulp-uglify'),
  webpackStream = require('webpack-stream');

gulp.task('js-build', function () {
  return gulp.src('./src/js/hs-toggle-password.js')
    .pipe(webpackStream({
      mode: 'development',
      output: {
        library: 'HSTogglePassword',
        libraryTarget: 'umd',
        libraryExport: 'default',
        filename: 'hs-toggle-password.js',
      },
      module: {
        rules: [
          {
            test: /\.(js)$/,
            exclude: /(node_modules)/,
            loader: 'babel-loader',
            query: {
              presets: ["@babel/preset-env"]
            }
          }
        ]
      }
    }))
    .pipe(gulp.dest('./dist/js'))
    .pipe(uglify())
    .pipe(rename({
      suffix: '.min'
    }))
    .pipe(gulp.dest('./dist/js'))
});

gulp.task('main-watch', function () {
  gulp.watch('./src/js/**/*.js', gulp.series('js-build'));
});

// Default Task
gulp.task('default', gulp.series('main-watch'));
