﻿using Microsoft.AspNetCore.Mvc;
using Ravco.Abp.AspNetCore.Mvc.UI.Theme.Front.Themes.Front.Components;
using Volo.Abp.AspNetCore.Mvc.UI.Theme.Shared.Views.Error;

namespace Ravco.Abp.AspNetCore.Mvc.UI.Theme.Front.Views.Error.DefaultErrorComponent;

public class FrontErrorViewComponent : FrontViewComponentBase
{
    public IViewComponentResult Invoke(AbpErrorViewModel model, string defaultErrorMessageKey)
    {
        var frontModel = new FrontErrorPageModel
        {
            ErrorInfo = model.ErrorInfo,
            HttpStatusCode = model.HttpStatusCode,
            DefaultErrorMessageKey = defaultErrorMessageKey
        };

        return View("~/Views/Error/DefaultErrorComponent/Default.cshtml", frontModel);
    }
}
